-- =============================================
-- SaveToDB Framework for PostgreSQL
-- Version 8.7, March 12, 2018
--
-- This script upgrades SaveToDB Framework 8.6 to SaveToDB Framework 8.7
--
-- Copyright 2015-2018 Gartle Technology Corporation
-- =============================================

CREATE TABLE xls.workbooks (
    id serial NOT NULL,
    name varchar(128) NOT NULL,
    template varchar(255) NULL,
    definition text NOT NULL,
    PRIMARY KEY (id)
);

CREATE UNIQUE INDEX ix_workbooks ON xls.workbooks USING BTREE (name);

GRANT SELECT ON TABLE xls.workbooks     TO xls_users;

GRANT SELECT, INSERT, UPDATE, DELETE ON TABLE xls.workbooks     TO xls_developers;

INSERT INTO xls.handlers (table_schema, table_name, column_name, event_name, handler_schema, handler_name, handler_type, handler_code, target_worksheet, menu_order, edit_parameters) VALUES ('xls', 'workbooks',    NULL, 'Actions', 'HTTP', 'Online Help', 'HTTP', 'http://www.savetodb.com/savetodb8/configuring-workbooks.htm',      NULL, 11, NULL);
